﻿@using System.Security.Claims
@{
    ViewData["Title"] = "Adviser List";
    var role = User.FindFirst(ClaimTypes.Role)?.Value;
    var area = role == Roles.FirmPrincipal ? "firm-principal" : role == Roles.FirmAdmin ? "firm-admin" : "adviser";
    var additionalRoles = ViewBag.additionalRoles;
    bool hasFirmAdminRole = role == Roles.FirmAdmin || (!string.IsNullOrEmpty(additionalRoles) && additionalRoles.Contains(Roles.FirmAdmin));
    bool hasComplianceRole = !string.IsNullOrEmpty(additionalRoles) ? additionalRoles.Contains(AdminRoleEnum.Compliance.ToString()) : false;
    var userLoginGuid = User.Claims.FirstOrDefault(c => c.Type == "UserLoginGuid").Value;
}
<div class="container">
    <div class="card">
        <div class="card-header flex-wrap border-0 pt-6 pb-0">
            <div class="card-title mb-0">
                <div class="d-flex justify-content-between">
                    <div class="flex-grow-1">
                        <h3 class="card-label text-primary">
                            Adviser List
                        </h3>
                    </div>
                    <div class="align-self-center">
                        @if (role == Roles.FirmAdmin || role == Roles.FirmPrincipal)
                        {
                            <button class="btn btn-primary btn-sm font-size-h6 font-weight-bold btn-adviser-add btn-add"><i class="fas fa-plus"></i>New Adviser</button>
                        }
                    </div>
                </div>
            </div>
        </div>
        <div class="card-body">
            <div class="datatable datatable-bordered" id="adviser_list"></div>
        </div>
    </div>
</div>
<div class="modal" id="AdviserModal" tabindex="-1" role="dialog" aria-labelledby="exampleModalLabel" aria-hidden="true"></div>
@section scripts{
    <script>
        localStorage.setItem("adviserLastPageHref", '@area/adviser-list');
        $(document).on("click", ".btn-adviser-add,.btn-adviser-edit", function () {
            KTApp.blockPage({ overlayColor: '#000000', state: 'primary', message: 'Please wait...' });
            var guid = $(this).attr("data-guid");
            loadPartialView(`admin/adviser/addadviser?guid=${guid}`, "AdviserModal");
            setTimeout(function () { KTApp.unblockPage(); }, 1000);
            $("#AdviserModal").modal({ backdrop: 'static' });
        });
        var firmId = $("#hdnFirmId").val();
        var ktDataTablOptions = ktDataTableDefaultConfigOptions;
        ktDataTablOptions.source = `admin/adviser/fetchadvisers`;
        window['datatable'] = $('#adviser_list').KTDatatable({
            columnFilter: true,
            data: ktDataTablOptions,
            columns: [
                { field: 'id', title: '#', width: 85, filter: { maxlength: 5, additionalClasses: "numericOnly-no-placeholder" } },
                {
                    field: 'userData.name', title: 'Name/Email', width: 330, filter: { container: "AdviserName" },
                    template: function (row) {
                        var isSetupCompleted = row.setupCompletedDate != null && row.setupCompletedDate.length > 2
                        var initial = [row.userData.firstName, row.userData.lastName].map((n) => n[0]).join("").substring(0, 2);
                        var color = getRandomColor();
                        var hasDob = row.userData.dateOfBirth != null && new Date(row.userData.dateOfBirth).getFullYear() != 1;
                        var tooltipHtml = "Pending Items To Complete";
                        tooltipHtml += "<ul>";
                        if (!isSetupCompleted)
                            tooltipHtml += `<li>Password setup process</li>`;
                        if (!hasDob)
                            tooltipHtml += `<li>Date of Birth</li>`;
                        if (!row.adviserContactInfo)
                            tooltipHtml += `<li>Contact Information</li>`;
                        if (!row.userData.riaId)
                            tooltipHtml += `<li>Select RIA</li>`;
                        tooltipHtml += "</ul>";
                        var warningHtml = !(hasDob || row.adviserContactInfo || row.userData.riaId > 0) ?
                            `<span class="fa-stack pulse pulse-warning ml-2" data-toggle="tooltip" data-html="true" data-original-title="${tooltipHtml}" data-placement="right" role = "button" >
                                                     <i class="fas fa-play fa-stack-1x text-dark icon-nm" style="transform: rotate(30deg);left:1px;top:3px"></i>
                                                     <i class="fas fa-exclamation-triangle fa-stack-1x text-warning"></i>
                                                     <span class="pulse-ring" style="margin-left:-4px;margin-top:-5px"></span>
                                                 </span>` : '';
                        return `<div class="d-flex align-items-center">
                                                        <div class="symbol symbol-40 flex-shrink-0">
                                                             <div class="symbol-label text-white" style="background:${color}">${initial}</div>
                                                        </div>
                                                        <div class="ml-2">
                                                            <div class="text-dark-75 font-weight-bold line-height-sm">${row.userData.name}</div>
                                                            <div class="text-primary">${row.username}</div>
                                                        </div>
                                                        ${warningHtml}
                                                    </div>`;
                    }
                },
                {
                    field: 'roles', title: 'Roles', sortable: false, width: 190, filter: { filterType: "multiselect", additionalClasses: `roles-filter-dropdown-${firmId}` },
                    template: function (row) {
                        var label_class = "";
                        label_class = row.adminRole == AdminRoleEnum.FIRMPRINCIPAL ? "dark" : row.adminRole == AdminRoleEnum.FIRMADMIN ? "warning" : row.adminRole == AdminRoleEnum.COMPLIANCE ? "info" : "success";
                        var html = `<span class="label label-outline-${label_class} label-inline mr-2 mb-2 font-weight-bold">${row.adminRoleString}</span>`;
                        row.permissions.forEach(function (item) {
                            label_class = item.roleType == AdminRoleEnum.FIRMADMIN ? "warning" : item.roleType == AdminRoleEnum.COMPLIANCE ? "info" : "success";
                            html += `<span class="label label-${label_class} label-inline mr-2 mb-2">${item.roleTypeString}</span>`;
                        })
                        return html;
                    }
                },
                {
                    field: 'setupCompletedDate', title: 'Password&nbsp;Setup', sortable: false, width: 125,
                    template: function (row) {
                        var date = row.setupCompletedDate;
                        return getDataTableDateWithHtml(date);
                    },
                },
                {
                    field: 'lastLogin', title: 'Last Login', sortable: false, width: 80,
                    template: function (row) {
                        var date = row.lastLogin;
                        return getDataTableDateWithHtml(date)
                    }
                },
                {
                    field: 'actions', title: 'Actions', width: 120, sortable: false, overflow: 'visible',
                    template: function (row) {
                        var isSetupCompleted = row.setupCompletedDate != null && new Date(row.setupCompletedDate).getFullYear() != 1;
                        var hasDob = row.userData.dateOfBirth != null && new Date(row.userData.dateOfBirth).getFullYear() != 1;
                        var isValidAdv2B = hasDob && row.adviserContactInfos.length && row.userData.riaId > 0;
                        var tz = new Date().getTimezoneOffset();
                        var hasComplianceRole = '@hasComplianceRole' == "True";
                        var isOwner = '@userLoginGuid' == row.guid;
                        var resend_html = !isSetupCompleted ? `<button class="btn btn-sm btn-icon resend-invitation-button" data-toggle="tooltip" data-original-title="Resend Invitation" onclick="reinvite(this,${AdminRoleEnum.ADVISER},'${row.guid}')">
                                                                    <img src="/images/email-resend-icon.png" height="25" />
                                                                    <i class="fa fa-redo text-warning icon-sm resend-invitation-icon" aria-hidden="true" style="left: 64px;top: 29px;"></i>
                                                                </button>` : "";
                        var adv2bHtml = isValidAdv2B ? `<a href="adviser/adv-2b?token=${encodeURIComponent(row.encryptedGuid)}&tz=${tz}" target="_blank" class="btn btn-sm btn-icon" data-toggle="tooltip" data-original-title="ADV 2B">
                                                                                <i class="far fa-file-alt icon-2x text-primary icon-xl" aria-hidden="true"></i>
                                                                            </a>` : "";
                        var viewProfileHtml = isSetupCompleted && hasComplianceRole && !isOwner ?
                            `<a class="ml-1" href="admin/account/adviserlogin?guid=${row.guid}" target="_blank" data-toggle="tooltip" data-original-title="View Profile">
                                                            <img src="/images/view-profile.png" height="30" />
                                                         </a>` : "";
                        return `${viewProfileHtml}
                                                    <button class="btn btn-sm btn-icon ml-2 btn-adviser-edit" data-toggle="tooltip" data-original-title="Edit" data-guid="${row.guid}">
                                                          <img src="/images/edit-icon.png" height="25" />
                                                    </button>
                                                    ${resend_html}
                                                    ${adv2bHtml}`;
                    },
                }
            ],
        });
        $(`#adviser_list`).on('datatable-on-init', function (e, data) {
            bindRolesDropdown(firmId);
        });
    </script>
}